#include "SamplingBehavior.h"
// #include "Montecarlo.h"
#include "Model.h"
#include <cmath>

const double pi = 3.14159265358979323846;

AngleIntervalSampling::AngleIntervalSampling(double lower_bound, double upper_bound) : SamplingBehavior(lower_bound, upper_bound) {}

void AngleIntervalSampling::sweep(Angle_Eta &model) {
	double energy_before, energy_after, old_value, r;
	int n_g = model.n_g;
	int n = model.n;
	int counter = 1;

	for (int i = 1; i < n_g+n; i++)
	{
		if (counter < model.reference_generators.size() && model.reference_generators[counter] == i) {
			counter++;
		} else {
			energy_before = model.energy();

			old_value = model.angles[i];
			model.angles[i] += variable_distribution(generator);
			model.angles[i] = fmod(model.angles[i],2 * pi);

			energy_after = model.energy();

			if (energy_after > energy_before) {
				r = zero_one_distribution(generator);
				if(exp(model.beta*(energy_before - energy_after)) < r) {
					model.angles[i] = old_value;
				}
			}
		}
	}
}