#include "SamplingBehavior.h"
// #include "Montecarlo.h"
#include "Model.h"

EtaIntervalSampling::EtaIntervalSampling(double lower_bound, double upper_bound) : EtaSamplingBehavior(lower_bound, upper_bound) {
	counter = 0;
}

void EtaIntervalSampling::sweep(Angle_Eta &model) {
	double energy_before, energy_after, old_value, r;
	int n_l = model.n_l;
	bool swapped;

	for (int i = 0; i < n_l; i++)
	{
		energy_before = model.energy();

		old_value = model.etas[i];
		// if (old_value > 0.2) {
		model.etas[i] += variable_distribution(generator);
		// }
		// else if (counter++ < 5) {
		// 	model.etas[i] += variable_distribution(generator);
		// }
		// else {
		// 	model.etas[i] = 1 - model.etas[i];
		// 	counter = 0;
		// }

		swapped = true;
		if (model.etas[i] >= 1 || model.etas[i] <= 0) {
			model.etas[i] = old_value;
			swapped = false;
		} else {
			energy_after = model.energy();

			if (energy_after > energy_before) {
				r = zero_one_distribution(generator);
				if(exp(model.beta*(energy_before - energy_after)) < r) {
					model.etas[i] = old_value;
					swapped = false;
				}
			}	
		}

		if (swapped) {
			manage_lines(model, model.etas[i], old_value, i);
		}
	}
}