#include "Model.h"

Model::Model(string output_filepath) {
	this->output_filepath = output_filepath;
}

Model::~Model() {}

double Model::big_F(double eta) {
	double a = 10;
	double b = 6;
	double C = 0;

	return a/5*pow(eta,5) - b*eta + log(10*eta*(1-eta))/a + C;
}

void Model::create_graph() {
	for (int i = 0; i < n_g+n; i++) {
		for (int j = 0; j < n_g+n; j++) {
			if (B[i][j] != 0) {
				add_edge(i, j, G);
			}
		}
	}
	// for (int i = 0; i < index_to_lines.size(); i++) {
	// 	add_edge(index_to_lines[i][0], index_to_lines[i][1], G);
 //    }

    vector<int> component(num_vertices(G));
    n_components = connected_components(G, &component[0]);
    
    // cout << "Total number of components: " << n_components << endl;
    // for (i = 0; i != component.size(); i++)
    //   cout << "Vertex " << i <<" is in component " << component[i] << endl;
    // cout << endl;
}

vector<double> Model::read_vector(boost::property_tree::ptree root, string key) {
	namespace pt = property_tree;
	
	vector<double> result;
	for (pt::ptree::value_type &entry : root.get_child(key)) {
		result.push_back(entry.second.get_value<double>());
	}	

	return result;
}

vector<vector<int>> Model::read_int_matrix(boost::property_tree::ptree root, string key) {
	namespace pt = property_tree;

	vector<vector<int>> result;

	int i = 0;
	for (pt::ptree::value_type &row : root.get_child(key)) {
		result.push_back(vector<int>());

		for (pt::ptree::value_type &cell : row.second) {
			result[i].push_back(cell.second.get_value<int>());
		}
		i++;
	}

	return result;
}

vector<vector<double>> Model::read_double_matrix(boost::property_tree::ptree root, string key) {
	namespace pt = property_tree;

	vector<vector<double>> result;

	int i = 0;
	for (pt::ptree::value_type &row : root.get_child(key)) {
		result.push_back(vector<double>());

		for (pt::ptree::value_type &cell : row.second) {
			result[i].push_back(cell.second.get_value<double>());
		}
		i++;
	}

	return result;
}
