#include <fstream>
#include "Montecarlo.h"
#include "Model.h"

Montecarlo::Montecarlo(Model &model, int n_steps, string output_filepath) {
	this->model = &model;
	this->n_steps = n_steps;
	this->output_filepath = output_filepath; 
}

Montecarlo::~Montecarlo() {
}

void Montecarlo::run() {
	ofstream output(output_filepath);
	for (int i = 0; i < n_steps; i++) {
		model->update();
		model->print(output);
	}
	output.close();
}