#include <random>
#include "Model.h"
using namespace std;

// class Model;
// class Eta_Model;
class Angle_Eta;

class SamplingBehavior 
{
	public:
		SamplingBehavior(double lower_bound, double upper_bound);
		virtual void sweep(Angle_Eta &model) = 0;

		mt19937 generator;
		uniform_real_distribution<> variable_distribution;
		uniform_real_distribution<> zero_one_distribution;
};

class AngleIntervalSampling: public SamplingBehavior 
{
	public:
		AngleIntervalSampling(double lower_bound, double upper_bound);
		void sweep(Angle_Eta &model);
};

class EtaSamplingBehavior: public SamplingBehavior
{
	public:
		EtaSamplingBehavior(double lower_bound, double upper_bound);
		void manage_lines(Angle_Eta &model, double new_value, double old_value, int index);
		vector<int> component_nodes(vector<int> component, int component_index, int n_g);
		vector<int> component_generators(vector<int> component, int component_index, int n_g);
		void balance_power(Angle_Eta &model, int num, vector<int> component);
};

class EtaIntervalSampling: public EtaSamplingBehavior
{
	public:
		EtaIntervalSampling(double lower_bound, double upper_bound);
		void sweep(Angle_Eta &model);
		int counter;

};

class EtaGlobalSampling: public EtaSamplingBehavior
{
	public:
		EtaGlobalSampling(double lower_bound, double upper_bound);
		void sweep(Angle_Eta &model);

};