from math import log
from matplotlib import pyplot as plt
import numpy as np

def big_F(eta):
	a = 10
	b = 5.5
	C = 0

	return a/5*eta**5 - b*eta + np.log(10*eta*(1-eta))/a + C;

def phi(lamda, eta):
	return lamda*eta - big_F(eta)

def new_phi(lamda, eta):
	return phi(lamda,x)-(1.01-x)*big_F(1-x)

def new_phi_plot():
	x = np.linspace(0,1,400)
	lam = np.linspace(0,1,9)

	axes = []
	for i in range(9):
		ax = plt.subplot(3,3,i+1)
		ax.tick_params(direction="in", right=True, top=True)
		axes.append(ax)
		plt.title(r"$\lambda_{\ell}$ = " + str(lam[i]), fontsize=20)
		plt.plot(x,new_phi(lam[i],x))

	axes[0].set_ylabel(r"$\phi_{new}(\eta_{\ell})$", fontsize=20)
	axes[3].set_ylabel(r"$\phi_{new}(\eta_{\ell})$", fontsize=20)
	axes[6].set_ylabel(r"$\phi_{new}(\eta_{\ell})$", fontsize=20)
	axes[6].set_xlabel(r"$\eta_{\ell}$", fontsize=20)
	axes[7].set_xlabel(r"$\eta_{\ell}$", fontsize=20)
	axes[8].set_xlabel(r"$\eta_{\ell}$", fontsize=20)

	plt.show()

def phi_plot():
	x = np.linspace(0,1,4000)
	lam = np.linspace(0,1,9)

	fig = plt.figure()
	ax = fig.gca()
	plt.plot(x,phi(0,x), label=r"$\lambda_{\ell} = 0$")
	plt.plot(x,phi(1,x), label=r"$\lambda_{\ell} = 1$")
	ax.tick_params(direction="in", right=True, top=True)
	ax.set_ylabel(r"$\phi(\eta_{\ell})$", fontsize=20)
	ax.set_xlabel(r"$\eta_{\ell}$", fontsize=20)
	plt.legend(fontsize=12)
	plt.show()

	# for i in range(9):
	# 	ax = plt.subplot(3,3,i+1)
	# 	ax.tick_params(direction="in", right=True, top=True)
	# 	axes.append(ax)
	# 	plt.title(r"$\lambda_{\ell}$ = " + str(lam[i]), fontsize=20)
	# 	plt.plot(x,phi(lam[i],x))

	# axes[0].set_ylabel(r"$\phi(\eta_{\ell})$", fontsize=20)
	# axes[3].set_ylabel(r"$\phi(\eta_{\ell})$", fontsize=20)
	# axes[6].set_ylabel(r"$\phi(\eta_{\ell})$", fontsize=20)
	# axes[6].set_xlabel(r"$\eta_{\ell}$", fontsize=20)
	# axes[7].set_xlabel(r"$\eta_{\ell}$", fontsize=20)
	# axes[8].set_xlabel(r"$\eta_{\ell}$", fontsize=20)

	# plt.show()

phi_plot()